#include <sys/types.h>
#include <stdio.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include "proto.h"
#define CHUNK_SIZE 256*512

#define PICTURE_START	0x00
#define GROUP_START	0xb8
#define MPEG_END	0xb9
#define PACK_START	0xba
#define SYSTEM_START	0xbb

#define PICTURE_CODING_MASK              0x38
#define PICTURE_CODING_SHIFT             0x03
#define PICTURE_CODING_INTRA             0x01
#define PICTURE_CODING_PREDICTIVE        0x02
#define PICTURE_CODING_BIDIRECTIONAL     0x03

int startchunk=1;

static void
usage(void)
{
  printf("vsplit [options] <infile> <videofile> <audiofile>\n");
  printf("options:\n");
  printf("  -0                 parse chunk 0\n");
  printf("  -h                 help\n");
  exit(1);
}

int
main(int argc, char *argv[])
{
  char *fname;
  int fd, chunk;
  uint8_t buf[CHUNK_SIZE];
  extern char *optarg;
  extern int optind;
  int c;

  while ((c = getopt(argc, argv, "h0")) != -1) {
    switch (c) {
    case '0': startchunk=0; break;
    case 'h':
    default: usage();
    }
  }

  argc -= optind;
  argv += optind;

  if (argc < 1) usage();
  fname = argv[0];
  fd = open(fname, O_RDONLY);


  /* discard the first chunk - it often contains garbage */
  if (startchunk==1) {
    read(fd, buf, CHUNK_SIZE); chunk=1;
  } else chunk=0;

  while (read(fd, buf, CHUNK_SIZE) == CHUNK_SIZE) {
    parse_chunk(buf, chunk, 0, stdout);
     printout_recs(buf, stdout);
    chunk++;
  }
  return(0);
}
