#include <sys/types.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include "proto.h"
#define CHUNK_SIZE 256*512

void usage(void)
{
  printf("vsplit [options] <infile> <videofile> <audiofile>\n");
  printf("options:\n");
  printf("    -h  help\n");
  exit(1);
}

int main(int argc, char *argv[])
{
  char *fname;
  FILE *zin, *audio_file, *video_file;
  u_int8_t buf[CHUNK_SIZE];
  extern char *optarg;
  extern int optind;
  int audio_fd, video_fd;
  int c;

  while ((c = getopt(argc, argv, "h")) != -1) {
    switch (c) {
    case 'h':
    default: usage(); exit(1);
    }
  }

  argc -= optind; argv += optind;

  if (argc < 3) { usage(); }

  fname = argv[0];
  zin = fopen(fname, "r");
  if (zin == NULL) { printf("Cannot read file %s\n", fname); exit(1); }
  video_file = fopen(argv[1], "w");
  if (video_file== NULL) { printf("Cannot write file %s\n", argv[1]); exit(1); }
  audio_file = fopen(argv[2], "w");
  if (audio_file== NULL) { printf("Cannot write file %s\n", argv[2]); exit(1); }
  video_fd = fileno(video_file);
  audio_fd = fileno(audio_file);

  /* discard the first chunk - it often contains garbage */
  fread(buf, 1, CHUNK_SIZE, zin);

  while (fread(buf, 1, CHUNK_SIZE, zin) == CHUNK_SIZE) {
   parse_chunk(buf,1,1,NULL);
   play_chunk(buf, audio_fd, video_fd); 
  }

  fclose(audio_file);
  fclose(video_file);
  exit(1);
}
